"use strict";

require("core-js/modules/es6.weak-map.js");
require("core-js/modules/es6.string.iterator.js");
require("core-js/modules/es6.object.to-string.js");
require("core-js/modules/es6.array.iterator.js");
require("core-js/modules/web.dom.iterable.js");
require("core-js/modules/es6.object.define-property.js");
require("core-js/modules/es6.object.get-own-property-descriptor.js");
exports.__esModule = true;
exports["default"] = void 0;
exports.enableCacheDB = enableCacheDB;
var _indexedDbAsync = _interopRequireWildcard(require("indexed-db-async"));
var _fetch = require("./fetch");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function getLastMonthTime() {
  var now = new Date();
  now.setMonth(now.getMonth() - 1);
  return now.getTime();
}
if (!_fetch.globalModule.db && (0, _indexedDbAsync.isSupportIndexedDB)()) {
  _fetch.globalModule.cacheDB = false;
  var db = _fetch.globalModule.db = new _indexedDbAsync["default"]('import-remote-global-db', 1, [{
    name: _fetch.TABLE_NAME,
    key: 'url',
    indexes: [{
      name: 'timestamp'
    }]
  }]);
  // delete last month cache
  db.deleteRange(_fetch.TABLE_NAME, "timestamp > " + getLastMonthTime());
}
function enableCacheDB(enable) {
  if (enable === void 0) {
    enable = true;
  }
  _fetch.globalModule.cacheDB = enable;
}
var _default = _fetch.globalModule.db;
exports["default"] = _default;