"use strict";

require("core-js/modules/es6.weak-map.js");
require("core-js/modules/es6.string.iterator.js");
require("core-js/modules/es6.array.iterator.js");
require("core-js/modules/web.dom.iterable.js");
require("core-js/modules/es6.object.define-property.js");
require("core-js/modules/es6.object.get-own-property-descriptor.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
require("core-js/modules/es6.object.to-string.js");
require("core-js/modules/es6.promise.js");
require("core-js/modules/es6.regexp.replace.js");
require("core-js/modules/es6.regexp.constructor.js");
require("core-js/modules/es6.array.map.js");
require("core-js/modules/es6.regexp.match.js");
require("core-js/modules/es6.string.ends-with.js");
var _base = _interopRequireDefault(require("base-64"));
var _fetch = _interopRequireWildcard(require("./fetch"));
var _utils = require("./utils");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var scopeNameRegx = /\(import-remote\)\/((?:@[^/]+\/[^/]+)|(?:[^@][^/]+))/;

/** @type {import('../types/importJs').default}  */
function importJs(url, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
    _ref$cached = _ref.cached,
    cached = _ref$cached === void 0 ? _fetch.globalCached : _ref$cached,
    _ref$timeout = _ref.timeout,
    timeout = _ref$timeout === void 0 ? _utils.DEFAULT_TIMEOUT : _ref$timeout,
    global = _ref.global,
    sync = _ref.sync,
    cacheDB = _ref.cacheDB,
    scopeName = _ref.scopeName,
    host = _ref.host,
    devtool = _ref.devtool,
    nocache = _ref.nocache,
    beforeSource = _ref.beforeSource,
    method = _ref.method,
    publicPath = _ref.publicPath,
    sourcemapHost = _ref.sourcemapHost;
  if (!cached._js) (0, _utils.innumerable)(cached, '_js', {});
  var next = function next(url) {
    var cacheUrl = (0, _utils.getCacheUrl)(url, scopeName);
    if (cached._js[cacheUrl]) return cached._js[cacheUrl];
    var prom = new Promise(function (resolve, reject) {
      (0, _fetch["default"])(url, {
        timeout: timeout,
        sync: sync,
        cacheDB: cacheDB,
        nocache: nocache,
        beforeSource: beforeSource,
        method: method
      }).then(function (source) {
        try {
          var isEval = /^eval/.test(String(devtool));
          if (host && source) {
            if (!/\/$/.test(host)) host += '/';
            if ((0, _utils.isEvalDevtool)(devtool)) {
              if (isEval) {
                source = source.replace(/\/\/# sourceURL=\[module\]\\n/g, '\\n');
                source = source.replace(/\/\/# sourceURL=(webpack-internal:\/\/\/[A-Za-z/\-_0-9.@+[\]]+)\\n/g, function (m, p1) {
                  return '\\n';
                } // `//# sourceURL=${host}__get-internal-source?fileName=${encodeURIComponent(p1)}\\n`
                );
              }

              var regx = new RegExp("\\/\\/# sourceMappingURL=data:application\\/json;charset=utf-8;base64,([0-9A-Za-z=/+.-]+)" + (isEval ? '\\\\n' : '(?:\\n|$)'), 'g');
              source = source.replace(regx, function (m, p1) {
                var sourcemap = JSON.parse(_base["default"].decode(p1));
                sourcemap.sources = sourcemap.sources.map(function (src) {
                  if (scopeName) {
                    var _ref2 = src.match(scopeNameRegx) || [],
                      srcScopeName = _ref2[1];
                    if (srcScopeName && srcScopeName !== scopeName) {
                      src = src.replace(scopeNameRegx, "(import-remote)/[" + scopeName + "]");
                    }
                  }
                  if (/\?[a-z0-9]{4}$/.test(src)) src = src.substr(0, src.length - 5);
                  return /^https?:/.test(src) ? src : host + src;
                });
                return "//# sourceMappingURL=data:application/json;charset=utf-8;base64," + _base["default"].encode(JSON.stringify(sourcemap)) + (isEval ? '\\n' : m.endsWith('\n') ? '\n' : '');
              });
            } else {
              source = (0, _utils.transformSourcemapUrl)(url, source, {
                devtool: devtool,
                sourcemapHost: sourcemapHost,
                scopeName: scopeName,
                host: host,
                publicPath: publicPath
              });
            }
          }
          if (beforeSource) source = beforeSource(source, 'js', url, {
            isEval: isEval
          });
          var result = (0, _utils.requireFromStr)(source, {
            global: global,
            url: url
          });
          resolve(result);
        } catch (err) {
          if (err && !err.url) err.url = url;
          console.error(err, url, source);
          reject(err);
        }
      })["catch"](function (ex) {
        delete cached._js[cacheUrl];
        return reject(ex);
      });
    });
    cached._js[cacheUrl] = prom;
    return prom;
  };
  if (url.then) return url.then(next);
  return next(url);
}
var _default = importJs;
exports["default"] = _default;