"use strict";

require("core-js/modules/es6.weak-map.js");
require("core-js/modules/es6.string.iterator.js");
require("core-js/modules/es6.array.iterator.js");
require("core-js/modules/web.dom.iterable.js");
require("core-js/modules/es6.object.define-property.js");
require("core-js/modules/es6.object.get-own-property-descriptor.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
require("core-js/modules/es6.object.to-string.js");
require("core-js/modules/es6.promise.js");
require("core-js/modules/es6.string.trim.js");
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _fetch = _interopRequireWildcard(require("./fetch"));
var _utils = require("./utils");
var _excluded = ["cached"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/** @type {import('../types/importJson').default}  */
function importJson(url, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
    _ref$cached = _ref.cached,
    cached = _ref$cached === void 0 ? _fetch.globalCached : _ref$cached,
    options = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  if (!cached._json) (0, _utils.innumerable)(cached, '_json', {});
  var next = function next(url) {
    if (cached._json[url]) return cached._json[url];
    return cached._json[url] = new Promise(function (resolve, reject) {
      (0, _fetch["default"])(url, options).then(function (source) {
        try {
          resolve(JSON.parse(source.trim()));
        } catch (err) {
          console.error(err, source);
          reject(err);
        }
      })["catch"](function (ex) {
        delete cached._json[url];
        return reject(ex);
      });
    });
  };
  if (url.then) return url.then(next);
  return next(url);
}
var _default = importJson;
exports["default"] = _default;