"use strict";

require("core-js/modules/es6.weak-map.js");
require("core-js/modules/es6.string.iterator.js");
require("core-js/modules/es6.object.to-string.js");
require("core-js/modules/es6.array.iterator.js");
require("core-js/modules/web.dom.iterable.js");
require("core-js/modules/es6.object.define-property.js");
require("core-js/modules/es6.object.get-own-property-descriptor.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.version = exports["default"] = void 0;
require("core-js/modules/es6.array.for-each.js");
require("core-js/modules/es6.object.keys.js");
var _fetch = _interopRequireWildcard(require("./fetch"));
exports.fetch = _fetch["default"];
exports.requireJs = _fetch.requireJs;
var _utils = require("./utils");
exports.innumerable = _utils.innumerable;
exports.mergeObject = _utils.mergeObject;
exports.requireWithVersion = _utils.requireWithVersion;
exports.objectDefineProperty = _utils.objectDefineProperty;
var _remote = _interopRequireWildcard(require("./remote"));
exports.requireManifest = _remote.requireManifest;
var _module = _interopRequireDefault(require("./module"));
exports.RemoteModule = _module["default"];
var _requireFactory = _interopRequireDefault(require("./requireFactory"));
exports.createRequireFactory = _requireFactory["default"];
var _importJs = _interopRequireDefault(require("./importJs"));
exports.importJs = _importJs["default"];
var _importJson = _interopRequireDefault(require("./importJson"));
exports.importJson = _importJson["default"];
var _importCss = _interopRequireDefault(require("./importCss"));
exports.importCss = _importCss["default"];
var _jsonp = _interopRequireDefault(require("./jsonp"));
exports.jsonp = _jsonp["default"];
var _semver = require("./semver");
exports.satisfy = _semver.satisfy;
exports.versionLt = _semver.versionLt;
var _version = _interopRequireDefault(require("../plugin/version"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/** @type {string} */
var version = typeof "0.1.1-alpha.1" === 'undefined' ? undefined : "0.1.1-alpha.1";
exports.version = version;
var remoteExternal = {
  RemoteModule: _module["default"],
  createRequireFactory: _requireFactory["default"],
  fetch: _fetch["default"],
  requireJs: _fetch.requireJs,
  importJs: _importJs["default"],
  importJson: _importJson["default"],
  importCss: _importCss["default"],
  jsonp: _jsonp["default"],
  mergeObject: _utils.mergeObject,
  innumerable: _utils.innumerable,
  satisfy: _semver.satisfy,
  versionLt: _semver.versionLt,
  requireWithVersion: _utils.requireWithVersion,
  requireManifest: _remote.requireManifest,
  version: version,
  "default": _remote["default"]
};
(0, _utils.innumerable)(remoteExternal, '__esModule', true);
_remote["default"].use = function (plugin) {
  plugin && plugin.install(_remote["default"]);
};
_remote["default"].externals['import-remote'] = remoteExternal;
Object.keys(remoteExternal).forEach(function (key) {
  return key !== 'default' && (0, _utils.innumerable)(_remote["default"], key, remoteExternal[key]);
});
(0, _utils.innumerable)(_remote["default"], 'pv', _version["default"]);
var _default = _remote["default"];
exports["default"] = _default;