"use strict";

require("core-js/modules/es6.weak-map.js");
require("core-js/modules/es6.object.define-property.js");
require("core-js/modules/es6.object.get-own-property-descriptor.js");
exports.__esModule = true;
exports["default"] = void 0;
require("core-js/modules/es6.object.assign.js");
require("core-js/modules/es6.object.to-string.js");
require("core-js/modules/es6.promise.js");
require("core-js/modules/es6.string.iterator.js");
require("core-js/modules/es6.array.iterator.js");
require("core-js/modules/web.dom.iterable.js");
require("core-js/modules/es6.array.map.js");
require("core-js/modules/es6.array.slice.js");
var _remote = _interopRequireWildcard(require("./remote"));
var _fetch = _interopRequireWildcard(require("./fetch"));
var _utils = require("./utils");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/** @type {import('../types/module').RemoteModule} */
var RemoteModule = /*#__PURE__*/function () {
  function RemoteModule(host, options) {
    if (options === void 0) {
      options = {};
    }
    if (!options.resolveModuleUrl && !host) throw new Error('[RemoteModule]`host` can not empty！');
    this.host = (0, _utils.resolveRelativeUrl)(host);
    this.pathname = options.pathname || '';
    this.resolveModuleUrl = options.resolveModuleUrl || _fetch.resolveModuleUrl;
    delete options.resolveModuleUrl;
    this.options = options || {};
  }
  var _proto = RemoteModule.prototype;
  _proto.external = function external(name, module) {
    if (!this.options.externals) this.options.externals = {};
    if (typeof name === 'string') this.options.externals[name] = module;else Object.assign(this.options.externals, name);
  };
  _proto.isRequired = function isRequired(moduleName) {
    if (moduleName === void 0) {
      moduleName = 'index.js';
    }
    var url = this.resolveModuleUrl(this.host + this.pathname, moduleName, _fetch.resolveModuleUrl);
    return url.then ? url.then(function (url) {
      return Boolean(_remote["default"].cached[url]);
    }) : Promise.resolve(Boolean(_remote["default"].cached[url]));
  };
  _proto.prefetch = function prefetch(prefetchs) {
    var _this = this;
    if (prefetchs === void 0) {
      prefetchs = [];
    }
    return Promise.all(prefetchs.slice().map(function (moduleName) {
      return _this.require(moduleName);
    }));
  };
  _proto.exist = function exist(moduleName, options) {
    if (moduleName === void 0) {
      moduleName = 'index.js';
    }
    if (options === void 0) {
      options = {};
    }
    return (0, _fetch.existModule)(this.host + this.pathname, moduleName, options);
  };
  _proto.requireEntries = function requireEntries(entriesName, options) {
    if (entriesName === void 0) {
      entriesName = 'import-remote-entries.js';
    }
    if (options === void 0) {
      options = {};
    }
    var url = this.resolveModuleUrl(this.host + this.pathname, entriesName, _fetch.resolveModuleUrl);
    var next = function next(url) {
      return (0, _fetch["default"])(url, options).then(function (v) {
        return v ? JSON.parse(v) : {};
      });
    };
    return url.then ? url.then(next) : next(url);
  };
  _proto.requireMeta = function requireMeta(moduleName, options) {
    if (moduleName === void 0) {
      moduleName = 'index.js';
    }
    if (options === void 0) {
      options = {};
    }
    var url = this.resolveModuleUrl(this.host + this.pathname, moduleName, _fetch.resolveModuleUrl, options.sync);
    var next = function next(url) {
      return (0, _remote.requireManifest)(url, (0, _utils.mergeObject)({
        meta: true
      }, options)).then(function (r) {
        return r && r.meta || {};
      });
    };
    if (url.then) return url.then(next);
    return next(url);
  };
  _proto.requireMetaSync = function requireMetaSync(moduleName, options) {
    if (moduleName === void 0) {
      moduleName = 'index.js';
    }
    if (options === void 0) {
      options = {};
    }
    var result;
    this.requireMeta(moduleName, (0, _utils.mergeObject)({}, options, {
      sync: true
    })).then(function (r) {
      return result = r;
    });
    return result;
  };
  _proto.require = function require(moduleName, options) {
    var _this2 = this;
    if (moduleName === void 0) {
      moduleName = 'index.js';
    }
    if (options === void 0) {
      options = {};
    }
    var url = this.resolveModuleUrl(this.host + this.pathname, moduleName, _fetch.resolveModuleUrl, options.sync);
    var next = function next(url) {
      var _options = Object.assign({}, _this2.options);
      return (0, _remote["default"])(url, (0, _utils.mergeObject)(_options, options, {
        host: _this2.host
      }));
    };
    if (url.then) return url.then(next);
    return next(url);
  };
  _proto.requireSync = function requireSync(moduleName, options) {
    if (moduleName === void 0) {
      moduleName = 'index.js';
    }
    if (options === void 0) {
      options = {};
    }
    var result;
    this.require(moduleName, Object.assign({}, options, {
      sync: true
    })).then(function (r) {
      return result = r;
    });
    return result;
  };
  _proto["import"] = function _import(moduleName, options) {
    if (moduleName === void 0) {
      moduleName = 'index.js';
    }
    if (options === void 0) {
      options = {};
    }
    return this.require(moduleName, options).then(function (result) {
      result && result.__esModule && (result = result["default"]);
      return result;
    });
  };
  _proto.importSync = function importSync(moduleName, options) {
    if (moduleName === void 0) {
      moduleName = 'index.js';
    }
    if (options === void 0) {
      options = {};
    }
    var result = this.requireSync(moduleName, options);
    result && result.__esModule && (result = result["default"]);
    return result;
  };
  return RemoteModule;
}();
(0, _utils.innumerable)(RemoteModule, '__import_remote_module_class__', true);
var _default = RemoteModule;
exports["default"] = _default;