"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.batchReplace = batchReplace;
exports["default"] = void 0;
exports.requireManifest = requireManifest;
require("regenerator-runtime/runtime.js");
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
require("core-js/modules/es6.object.assign.js");
require("core-js/modules/es6.string.includes.js");
require("core-js/modules/es7.array.includes.js");
require("core-js/modules/es6.array.filter.js");
require("core-js/modules/es6.regexp.split.js");
require("core-js/modules/es6.regexp.replace.js");
require("core-js/modules/es6.function.name.js");
require("core-js/modules/es6.string.starts-with.js");
require("core-js/modules/es6.array.for-each.js");
require("core-js/modules/es6.array.is-array.js");
require("core-js/modules/es6.array.find.js");
require("core-js/modules/es7.string.pad-end.js");
require("core-js/modules/es6.object.to-string.js");
require("core-js/modules/es6.promise.js");
require("core-js/modules/es6.string.iterator.js");
require("core-js/modules/es6.array.iterator.js");
require("core-js/modules/web.dom.iterable.js");
require("core-js/modules/es6.array.map.js");
require("core-js/modules/es6.array.some.js");
require("core-js/modules/es6.object.keys.js");
require("core-js/modules/es6.regexp.constructor.js");
require("core-js/modules/es6.regexp.match.js");
var _escapeStringRegexp = _interopRequireDefault(require("escape-string-regexp"));
var _fetch = require("./fetch");
var _utils = require("./utils");
var _runtime2 = _interopRequireDefault(require("./runtime5"));
var _importCss = require("./importCss");
var _requireFactory = require("./requireFactory");
var _semver = require("./semver");
var _excluded = ["context", "document"];
function createContext(context, options) {
  if (options === void 0) {
    options = {};
  }
  if (!context) context = {};
  if (!context.window) context.window = window;
  context._cx_ = context.__context__ = context;
  (0, _utils.innumerable)(context, 'options', options);
  return context;
}
function checkContext(context, options) {
  if (options === void 0) {
    options = {};
  }
  if (!context) return;
  if (!context._cx_) context._cx_ = context.__context__;
  if (context.__windowProxy__ && !context.__wp__) {
    var wp = context.__wp__ = context._wp_ = context.__windowProxy__;
    var doc = wp.doc;
    Object.assign(wp, {
      d: doc,
      x: doc.html,
      b: doc.body,
      h: doc.head,
      g: wp.globals
    });
  }
  if (!context.options) (0, _utils.innumerable)(context, 'options', {});
  (0, _utils.copyOwnProperties)(context.options, options);
}
function resolvePath(modulePath) {
  if (modulePath.includes('!')) {
    var paths = modulePath.split('!').filter(Boolean);
    modulePath = paths[paths.length - 1] || '';
  }
  return modulePath.split('?')[0];
}
function resolveModulePath(modulePath, nodeModulesPath, currentNodeModulesPath) {
  if (!modulePath) return modulePath;
  nodeModulesPath = resolvePath(nodeModulesPath || '');
  currentNodeModulesPath = resolvePath(currentNodeModulesPath || '');
  if (nodeModulesPath && currentNodeModulesPath !== nodeModulesPath) {
    modulePath = modulePath.replace(currentNodeModulesPath, nodeModulesPath);
  }
  return nodeModulesPath;
}
function resolveModule(external, __require__, nodeModulesPath, currentNodeModulesPath) {
  if (!__require__.m) return;
  if (__require__.m[external.name]) return __require__.m[external.name];
  var modulePath = external.path && resolveModulePath(external.path, nodeModulesPath, currentNodeModulesPath);
  if (modulePath && __require__.m[modulePath]) return __require__(modulePath);
}
function createWindowProxy(windowProxy, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
    scopeName = _ref.scopeName,
    host = _ref.host,
    beforeSource = _ref.beforeSource;
  var context = windowProxy.context,
    _windowProxy$document = windowProxy.document,
    doc = _windowProxy$document === void 0 ? {
      html: document.documentElement,
      body: document.body,
      head: document.head
    } : _windowProxy$document,
    windowOthers = (0, _objectWithoutPropertiesLoose2["default"])(windowProxy, _excluded);
  var attachIframeLoad = function attachIframeLoad(el) {
    if (!el || el.__import_remote_iframe_load__) return;
    el.addEventListener && el.addEventListener('load', function () {
      try {
        if (el.src && !/^data:/.test(el.src)) return;
        if (el.contentWindow && !el.contentWindow.__wp__) {
          var _doc = {
            html: el.contentDocument,
            body: el.contentDocument.body,
            head: el.contentDocument.head,
            createElement: function createElement() {
              var _el$contentDocument;
              return (_el$contentDocument = el.contentDocument).createElement.apply(_el$contentDocument, arguments);
            },
            getElementById: function getElementById() {
              var _el$contentDocument2;
              return (_el$contentDocument2 = el.contentDocument).getElementById.apply(_el$contentDocument2, arguments);
            }
          };
          var _context = {
            doc: _doc,
            globals: {}
          };
          Object.assign(_context, {
            d: _doc,
            x: _doc.html,
            b: _doc.body,
            h: _doc.head,
            g: _context.globals
          });
          el.contentWindow.__wp__ = el.contentWindow._wp_ = el.contentWindow.__windowProxy__ = _context;
        }
      } catch (ex) {
        console.error(ex);
      }
    }, true);
    el.__import_remote_iframe_load__ = true;
  };
  doc.getElementById = function getElementByIdProxy(id, scoped) {
    if (scoped === true && !id.startsWith(scopeName)) id = scopeName + "-" + id;
    return document.getElementById(id);
  };
  doc.createElement = function (tagName, options) {
    var el = document.createElement(tagName, options);
    if (scopeName) el.setAttribute(_utils.ATTR_SCOPE_NAME, scopeName);
    if (el.nodeName === 'IFRAME') attachIframeLoad(el);
    if (!el.appendChild._import_remote_proxy_) {
      var _appendChild = el.appendChild;
      el.appendChild = function appendChildProxy(node, scoped) {
        if (node) {
          if (scoped === true && node.id && !node.id.startsWith(scopeName)) node.id = scopeName + "-" + node.id;
          if (host && node.nodeName === 'STYLE' && node.getAttribute(_importCss.ATTR_CSS_TRANSFORMED) == null) {
            var text = node.innerText;
            var newText = (0, _importCss.transformStyleHost)(text, host);
            if (beforeSource) newText = beforeSource(text, 'css');
            if (text !== newText) node.innerText = newText;
            node.setAttribute(_importCss.ATTR_CSS_TRANSFORMED, '');
          } else if (node.nodeName === 'IFRAME') attachIframeLoad(el);
        }
        return _appendChild.call(this, node);
      };
      (0, _utils.innumerable)(el.appendChild, '_import_remote_proxy_', true);
    }
    return el;
  };
  var globals = {};
  return Object.assign({
    doc: doc,
    globals: globals,
    d: doc,
    x: doc.html,
    b: doc.body,
    h: doc.head,
    g: globals
  }, windowOthers);
}
function getScopeName(__remoteModuleWebpack__, scopeName, host, order) {
  if (order === void 0) {
    order = 0;
  }
  var newScopeName = "" + scopeName + (order ? "_" + order : '');
  var currentManifest = __remoteModuleWebpack__.__moduleManifests__[newScopeName];
  if (currentManifest && host && currentManifest.host && !(0, _utils.isSameHost)(currentManifest.host, host)) {
    console.error("warning:[import-remote][" + host + ":" + newScopeName + "] scopename alreadly exist, will rename to [" + scopeName + "_" + (order + 1) + "]!");
    return getScopeName(__remoteModuleWebpack__, scopeName, host, ++order);
  }
  return newScopeName;
}

/** @type {import('../types/remote').batchReplace} */
function batchReplace(source, replaces) {
  replaces && replaces.filter(Boolean).forEach(function (_ref2) {
    var regx = _ref2[0],
      replace = _ref2[1];
    source = source.replace(regx, replace);
  });
  return source;
}
var splitSourceSize = 102400;
function splitSource(source, splitRegx, len) {
  if (len === void 0) {
    len = splitSourceSize;
  }
  var _split = function _split(src) {
    if (src.length <= len) return [src, ''];
    while (src.length > len && !splitRegx.test(src.charAt(len - 1))) {
      len++;
    }
    return [src.substr(0, len), src.substr(len, src.length)];
  };
  var ret = [];
  var restSource = source;
  while (restSource) {
    var _split2 = _split(restSource);
    source = _split2[0];
    restSource = _split2[1];
    ret.push(source);
  }
  return ret;
}
function resolveResult(result, options) {
  if (options.useEsModuleDefault && result && result.__esModule) result = result["default"];
  return result;
}
function requireModule(__require__, manifest) {
  if (!__require__) return;
  var result = __require__(manifest.entryId, manifest.entryFile);
  if (Array.isArray(manifest.entryId)) {
    var entryIndex = manifest.entryIndex;
    if ((0, _utils.isFunction)(entryIndex)) entryIndex = entryIndex.call(manifest, result, __require__);
    result = entryIndex == null ? result.find(function (v) {
      return v;
    }) : result[entryIndex];
  }
  return result;
}
function requireManifest(url, options) {
  return (0, _fetch.requireJs)(url, options).then(function (manifest) {
    if (!(0, _utils.isFunction)(manifest) || !manifest.iref) {
      options.done && options.done();
      return manifest;
    }
    var target = manifest(remote, options, {
      url: url
    });
    if (target) {
      if (options.meta) target = target.meta;
      manifest = target && (manifest.iref ? _utils.walkMainifest : function (v) {
        return v;
      })(target);
    }
    return manifest;
  });
}
var spacePads = new Array(100);
for (var i = 0; i < spacePads.length; i++) {
  spacePads[i] = ''.padEnd(i, ' ');
}

/**
 * @param {string} source
 * @param {number} offset
 * @param {string} match
 * @param {string} replaceStr
 */
function checkReplaceOffset(source, offset, match, replaceStr) {
  // if (/^ ?=/.test(source.substr(offset + match.length, 2))) return match;
  var newMatch = match;
  // if (offset && !/^(window|self|global|globalThis)\./.test(match)) {
  //   const [, prefixVar] = source.substr(offset - 12, 12).match(/(window|self|global|globalThis)\.$/) || [];
  //   if (prefixVar) {
  //     offset = Math.max(offset - prefixVar.length - 1, 0);
  //     newMatch = `${prefixVar}.` + match;
  //   }
  // }
  var padLen = newMatch.length - replaceStr.length;
  if (padLen > 0 && padLen < spacePads.length) replaceStr += spacePads[padLen];
  return offset && /^[.'"$_`\\]$/.test(source[offset - 1]) ? match : replaceStr;
}

/**
 * @typedef {import('../types/types').RemoteOptions} RemoteOptions
 */

/**
 * @template T
 * @param {string} url
 * @param {RemoteOptions} [options]
 * @returns {Promise<T>}
 */
function remote(url, options) {
  if (options === void 0) {
    options = {};
  }
  url = (0, _utils.resolveRelativeUrl)(url, {
    host: options.host,
    onHost: function onHost(host) {
      return options.host = host;
    }
  });
  var _options = options,
    _options$timeout = _options.timeout,
    timeout = _options$timeout === void 0 ? _utils.DEFAULT_TIMEOUT : _options$timeout,
    _options$externals = _options.externals,
    externals = _options$externals === void 0 ? {} : _options$externals,
    _options$globals = _options.globals,
    globals = _options$globals === void 0 ? {} : _options$globals,
    _options$getManifestC = _options.getManifestCallback,
    getManifestCallback = _options$getManifestC === void 0 ? null : _options$getManifestC,
    _options$onRuntimeCha = _options.onRuntimeChanged,
    onRuntimeChanged = _options$onRuntimeCha === void 0 ? null : _options$onRuntimeCha,
    _options$host = _options.host,
    host = _options$host === void 0 ? (0, _utils.getHostFromUrl)(url) : _options$host,
    _options$sync = _options.sync,
    sync = _options$sync === void 0 ? false : _options$sync,
    sourcemapHost = _options.sourcemapHost,
    beforeSource = _options.beforeSource,
    method = _options.method,
    cacheDB = _options.cacheDB,
    _options$windowProxy = _options.windowProxy,
    windowProxy = _options$windowProxy === void 0 ? {
      document: {
        html: document.documentElement,
        body: document.body,
        head: document.head
      }
    } : _options$windowProxy;
  var _options2 = options,
    scopeName = _options2.scopeName;
  var __remoteModuleWebpack__ = (0, _fetch.checkRemoteModuleWebpack)(windowProxy.context);
  var cached = windowProxy.context && windowProxy.context.cached || _fetch.globalCached;
  if (typeof scopeName === 'function') scopeName = scopeName(url, options);
  var cacheUrl = (0, _utils.getCacheUrl)(url, scopeName);
  if (cached[cacheUrl]) {
    return cached[cacheUrl].result.then( /*#__PURE__*/function () {
      var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/regeneratorRuntime.mark(function _callee(r) {
        return regeneratorRuntime.wrap(function _callee$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.t0 = getManifestCallback;
                if (!_context2.t0) {
                  _context2.next = 4;
                  break;
                }
                _context2.next = 4;
                return getManifestCallback(cached[cacheUrl].manifest);
              case 4:
                return _context2.abrupt("return", resolveResult(r, options));
              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee);
      }));
      return function (_x) {
        return _ref3.apply(this, arguments);
      };
    }());
  }
  cached[cacheUrl] = {
    manifest: null,
    result: new Promise( /*#__PURE__*/function () {
      var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(resolve, _reject) {
        var reject, isDone, manifest, newScopeName, manifestExternals, commonModuleOptions, commonModules, _moduleManifest, moduleManifest, requireExternal, context, globalObject, newGlobalObject, libraryTarget, beforeSourceRegx, hotUpdateGlobal, hotSourceRegx, jsonpFunction, jsonpSourceRegx, batchReplaces, ctx, __require__;
        return regeneratorRuntime.wrap(function _callee3$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                reject = function reject() {
                  delete cached[cacheUrl];
                  return _reject.apply(this, arguments);
                };
                _context4.prev = 1;
                isDone = false;
                _context4.next = 5;
                return requireManifest(url, {
                  timeout: timeout,
                  global: window,
                  nocache: true,
                  cacheDB: cacheDB,
                  sync: sync,
                  cached: cached,
                  method: method,
                  done: function done() {
                    return isDone = true;
                  }
                });
              case 5:
                manifest = _context4.sent;
                if (!isDone) {
                  _context4.next = 9;
                  break;
                }
                resolve(manifest);
                return _context4.abrupt("return");
              case 9:
                if (manifest.scopeName) {
                  _context4.next = 11;
                  break;
                }
                throw new Error('[import-remote:remote]scopeName can not be empty!');
              case 11:
                if (scopeName && manifest.scopeName !== scopeName) manifest.scopeName = scopeName;
                newScopeName = getScopeName(__remoteModuleWebpack__, manifest.scopeName, host);
                if (scopeName != newScopeName) scopeName = manifest.scopeName = newScopeName;
                if (cached[cacheUrl]) cached[cacheUrl].manifest = manifest;
                _context4.t0 = getManifestCallback;
                if (!_context4.t0) {
                  _context4.next = 19;
                  break;
                }
                _context4.next = 19;
                return getManifestCallback(manifest);
              case 19:
                if (!manifest.checkManifest) {
                  _context4.next = 22;
                  break;
                }
                _context4.next = 22;
                return manifest.checkManifest();
              case 22:
                // if (__remoteModuleWebpack__[scopeName]) {
                //   const ctx = __remoteModuleWebpack__[scopeName];
                //   const m = requireModule(ctx.require, manifest, true);
                //   if (m) return resolve(m);
                // }

                Object.assign(externals, remote.externals);
                manifestExternals = [].concat(manifest.externals, (manifest.shareModules || []).filter(function (v) {
                  return v.shareCommon;
                })).filter(function (v) {
                  return v && !(v.name in externals) && (!v["var"] || !window[v["var"]]);
                });
                commonModuleOptions = manifest.commonModules || [];
                if (!manifestExternals.length) {
                  _context4.next = 31;
                  break;
                }
                _context4.next = 28;
                return Promise.all(commonModuleOptions.filter(function (m) {
                  return m && m.url;
                }).map(function (m) {
                  var name = m.name;
                  if (name) {
                    if ((0, _utils.isFunction)(name)) name = name.call(m, options, manifest);
                    if (name && !manifestExternals.some(function (v) {
                      return v.name === name;
                    })) return;
                  }
                  var url = m.url;
                  var mHost = (0, _utils.resolveRelativeUrl)((0, _utils.isFunction)(m.host) ? m.host(options, manifest) : m.host, {
                    host: host
                  });
                  if ((0, _utils.isFunction)(url)) url = url.call(m, options, manifest);
                  url = (0, _utils.resolveRelativeUrl)(url, {
                    host: mHost || host,
                    onHost: m.host ? null : function (host) {
                      if (!m.host) m.host = host;
                    }
                  });
                  return remote(url, {
                    isCommonModule: true,
                    externals: externals,
                    globals: globals,
                    host: mHost || (0, _utils.getHostFromUrl)(url),
                    sync: sync,
                    cacheDB: cacheDB,
                    method: method,
                    // getManifestCallback: m.scoped ? getManifestCallback : undefined,
                    windowProxy: m.scoped ? windowProxy : undefined
                  }).then(function (result) {
                    var _ref5;
                    return name ? (_ref5 = {}, _ref5[name] = result && result.__esModule ? result["default"] : result, _ref5) : result;
                  });
                }));
              case 28:
                _context4.t1 = _context4.sent;
                _context4.next = 32;
                break;
              case 31:
                _context4.t1 = [];
              case 32:
                commonModules = _context4.t1;
                _context4.next = 35;
                return Promise.all(commonModules.filter(function (m) {
                  return m;
                }).map( /*#__PURE__*/function () {
                  var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(m) {
                    var modules;
                    return regeneratorRuntime.wrap(function _callee2$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            if (manifestExternals.length) {
                              _context3.next = 2;
                              break;
                            }
                            return _context3.abrupt("return");
                          case 2:
                            if (m.__esModule) m = m["default"];
                            if (!(0, _requireFactory.isRequireFactory)(m)) {
                              _context3.next = 9;
                              break;
                            }
                            _context3.next = 6;
                            return m(manifestExternals);
                          case 6:
                            _context3.t0 = _context3.sent;
                            _context3.next = 10;
                            break;
                          case 9:
                            _context3.t0 = m;
                          case 10:
                            modules = _context3.t0;
                            if ((0, _utils.isPlainObject)(modules)) {
                              Object.keys(modules).some(function (key) {
                                var idx = manifestExternals.find(function (v) {
                                  return v.name === key;
                                });
                                if (~idx) manifestExternals.splice(idx, 1);
                                return manifestExternals.length;
                              });
                            }
                            return _context3.abrupt("return", modules);
                          case 13:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee2);
                  }));
                  return function (_x4) {
                    return _ref6.apply(this, arguments);
                  };
                }()));
              case 35:
                commonModules = _context4.sent.filter(Boolean);
                if (!__remoteModuleWebpack__.__moduleManifests__[scopeName]) {
                  _moduleManifest = __remoteModuleWebpack__.__moduleManifests__[scopeName] = {};
                  _moduleManifest.timestamp = manifest.timestamp;
                  _moduleManifest.host = (0, _utils.joinUrl)(host, '');
                  _moduleManifest.jsChunks = manifest.jsChunks;
                  _moduleManifest.cssChunks = manifest.cssChunks;
                  _moduleManifest.hot = manifest.hot;
                  _moduleManifest.nodeModulesPath = manifest.nodeModulesPath;
                  _moduleManifest.entrys = {};
                }
                moduleManifest = __remoteModuleWebpack__.__moduleManifests__[scopeName];
                manifest.entryFile && (moduleManifest.entrys[manifest.entryFile] = manifest);
                if (!(moduleManifest.timestamp && manifest.timestamp !== moduleManifest.timestamp)) {
                  _context4.next = 45;
                  break;
                }
                console.error("warning:[import-remote:remote][" + scopeName + "]the timestamp(" + manifest.timestamp + ") of [" + url + "] is different with the entry module(" + moduleManifest.timestamp + ")!");
                _context4.t2 = onRuntimeChanged;
                if (!_context4.t2) {
                  _context4.next = 45;
                  break;
                }
                _context4.next = 45;
                return onRuntimeChanged(manifest, moduleManifest);
              case 45:
                requireExternal = function requireExternal(externalOrModuleId, isShare) {
                  var external = externalOrModuleId;
                  if (!(0, _utils.isPlainObject)(external)) external = {
                    name: external
                  };
                  var result = externals[external.name];
                  if (result === undefined) {
                    commonModules.some(function (m) {
                      if ((0, _utils.isFunction)(m)) result = m(external);else result = m[external.name];
                      return result !== undefined;
                    });
                  }
                  if (result === undefined) {
                    commonModuleOptions.some(function (option) {
                      var commonModuleContext = __remoteModuleWebpack__[option.name];
                      var commonModuleManifest = __remoteModuleWebpack__.__moduleManifests__[option.name];
                      result = commonModuleContext && commonModuleManifest && resolveModule(external, commonModuleContext.require || commonModuleContext.__require__, commonModuleManifest.nodeModulesPath, manifest.nodeModulesPath);
                      return result !== undefined;
                    });
                  }
                  if (result === undefined && external["var"]) result = window[external["var"]];
                  if (!isShare && result === undefined) {
                    console.error("warning:[import-remote:remote]module \"" + scopeName + "\" need external \"" + external.name + "\" !");
                  }
                  return result;
                };
                context = __remoteModuleWebpack__[scopeName];
                if (context) checkContext(context, options);else {
                  globalObject = manifest.windowObject || 'window';
                  newGlobalObject = manifest.globalObject || '__context__';
                  libraryTarget = manifest.libraryTarget;
                  beforeSourceRegx = manifest.beforeSourceRegx || function (regxStr) {
                    return regxStr;
                  };
                  hotUpdateGlobal = manifest.hotUpdateGlobal || 'webpackHotUpdate';
                  hotSourceRegx = hotUpdateGlobal ? new RegExp(beforeSourceRegx("" + (!libraryTarget || libraryTarget === 'var' ? '^(\\/\\*[A-z\\s*():/.",-]+\\*\\/\\n)?(?:"use strict";\\n?)?(\\/\\*[A-z\\s*():/.",-]+\\*\\/\\n)?' : '') + globalObject + "(?:(?:\\[\")|\\.)" + hotUpdateGlobal + "(?:\"\\])?", 'hot', {
                    remote: remote,
                    versionLt: _semver.versionLt,
                    satisfy: _semver.satisfy
                  })) : null;
                  jsonpFunction = manifest.jsonpFunction || 'webpackJsonp';
                  jsonpSourceRegx = new RegExp(beforeSourceRegx((!libraryTarget || libraryTarget === 'var' ? '^(?:\\/\\*[A-Za-z0-9\\s*():/.",\\-!_$@#%&~]+\\*\\/\\n)?(?:"use strict";\\n?)?(?:\\/\\*[A-Za-z0-9\\s*():/.",\\-!_$@#%&~]+\\*\\/\\n)?' : '') + "(?:var ([A-Za-z0-9_$]+);[A-Za-z0-9_$\\s=]+\\n?)?\\(" + globalObject + "(?:(?:\\[\")|\\.)" + jsonpFunction + "(?:\"\\])?\\s?=\\s?" + globalObject + "(?:(?:\\[\")|\\.)" + jsonpFunction + "(?:\"\\])?\\s?\\|\\|\\s?\\[\\]\\)", 'jsonp', {
                    remote: remote,
                    versionLt: _semver.versionLt,
                    satisfy: _semver.satisfy
                  }));
                  batchReplaces = manifest.batchReplaces && manifest.batchReplaces.map(function (v) {
                    if (!Array.isArray(v)) return v;
                    return v.map(function (w) {
                      if (typeof w !== 'string') return w;
                      return w.replace(/%SCOPE_NAME%/g, scopeName);
                    });
                  });
                  ctx = context = __remoteModuleWebpack__[scopeName] = createContext(windowProxy.context, options);
                  if (newGlobalObject === '__context__') newGlobalObject = '_cx_';
                  Object.assign(ctx, remote.globals, globals);
                  (0, _utils.innumerable)(ctx, '__remoteModuleWebpack__', __remoteModuleWebpack__);
                  (0, _utils.innumerable)(ctx, '__HOST__', host);
                  // innumerable(ctx, 'cached', cached);
                  ctx.__wp__ = ctx._wp_ = ctx.__windowProxy__ = createWindowProxy(windowProxy, {
                    scoped: manifest.scopeName,
                    host: host,
                    beforeSource: beforeSource
                  });
                  ctx.require = (0, _runtime2["default"])(Object.assign({}, manifest, {
                    scopeName: scopeName,
                    host: host,
                    context: ctx,
                    cached: cached,
                    cacheDB: cacheDB,
                    sync: sync,
                    sourcemapHost: sourcemapHost || manifest.sourcemapHost,
                    requireExternal: requireExternal,
                    beforeSource: function beforeSource(source, type, href, options) {
                      var _ctx$options;
                      if (options === void 0) {
                        options = {};
                      }
                      if (type === 'js') {
                        var sourcePrefix;
                        if (jsonpSourceRegx) {
                          var match = source.match(jsonpSourceRegx);
                          var _ref7 = match || [];
                          sourcePrefix = _ref7[0];
                          if (sourcePrefix) {
                            var appVar = match[1] || '';
                            var newSourcePrefix = (appVar ? "var " + appVar + "=" + globalObject + "." + appVar + "=\n" : '') + "(" + newGlobalObject + "['" + jsonpFunction + "'])";
                            source = (match.index ? source.substr(0, match.index) : '') + newSourcePrefix.padEnd(sourcePrefix.length, ' ') + source.substr(match.index + sourcePrefix.length);
                          }
                        }
                        if (!sourcePrefix && hotSourceRegx) {
                          var _match = source.match(hotSourceRegx);
                          var _ref8 = _match || [],
                            hotSourcePrefix = _ref8[0];
                          if (hotSourcePrefix) {
                            var _newSourcePrefix = "(" + newGlobalObject + "['" + hotUpdateGlobal + "'])";
                            source = (_match.index ? source.substr(0, _match.index) : '') + _newSourcePrefix.padEnd(hotSourcePrefix.length, ' ') + source.substr(_match.index + hotSourcePrefix.length);
                          }
                        }
                        var sources = splitSource(source, /[\s<>|&{}:,;()"'+=*![\]/\\]/);
                        sources.forEach(function (src, i) {
                          src = batchReplace(src, [[/\b(?:window\.)?document(\.getElementsBy(?:TagName(?:NS)?|Name|ClassName)|querySelector(All)?)\b/g, function (m, p1, offset, src) {
                            return checkReplaceOffset(src, offset, m, '_wp_.d.html' + p1);
                          }], [/\b(?:window\.)?document\.getElementById\b/g, function (m, offset, src) {
                            return checkReplaceOffset(src, offset, m, '__wp__.d.getElementById');
                          }], [/\b(?:window\.)?document\.createElement\b/g, function (m, offset, src) {
                            return checkReplaceOffset(src, offset, m, '__wp__.d.createElement');
                          }], [/\b(?:window\.)?document\.body\b/g, function (m, offset, src) {
                            return checkReplaceOffset(src, offset, m, '__wp__.d.body');
                          }], [/\b(?:window\.)?document\.head\b/g, function (m, offset, src) {
                            return checkReplaceOffset(src, offset, m, '__wp__.d.head');
                          }], [/\b(?:window\.)?document\.documentElement\b/g, function (m, offset, src) {
                            return checkReplaceOffset(src, offset, m, '__wp__.d.html');
                          }], ctx.__wp__.addEventListener ? [/\bwindow\.addEventListener\b/g, '__wp__.addEventListener'] : null, ctx.__wp__.removeEventListener ? [/\bwindow\.removeEventListener\b/g, '__wp__.removeEventListener'] : null]);
                          if (batchReplaces) src = batchReplace(src, batchReplaces);
                          if (manifest.globalToScopes) {
                            src = batchReplace(src, manifest.globalToScopes.map(function (varName) {
                              if (Array.isArray(varName)) return varName;
                              return [new RegExp("\\b" + (options.isEval ? '(\\\\n)?' : '') + "(?:window)\\." + (0, _escapeStringRegexp["default"])(varName) + "\\b", 'g'), function (m, offset, src) {
                                return checkReplaceOffset(src, offset, m, "_wp_.g." + varName);
                              }];
                            }));
                          }
                          sources[i] = src;
                        });
                        source = sources.join('');
                      }
                      if ((_ctx$options = ctx.options) != null && _ctx$options.beforeSource) source = ctx.options.beforeSource(source, type, href, options);
                      if (manifest.beforeSource) {
                        source = manifest.beforeSource(source, type, href, options, {
                          versionLt: _semver.versionLt,
                          satisfy: _semver.satisfy,
                          batchReplace: batchReplace,
                          checkReplaceOffset: checkReplaceOffset
                        });
                      }
                      return source;
                    }
                  }));
                  manifest.afterCreateRuntime && manifest.afterCreateRuntime(ctx.require, ctx);
                  options.afterCreateRuntime && options.afterCreateRuntime(ctx.require, ctx);
                }
                __require__ = context.require || context.__require__;
                manifest.externals.forEach(function (external) {
                  if (__require__.m[external.id] && __require__.m[external.id].__import_remote_external__) return;
                  var fn = function fn(module) {
                    if (fn.__import_remote_module__) return fn.__import_remote_module__.exports;
                    if (!module) module = {};
                    module.exports = requireExternal(external);
                    fn.__import_remote_module__ = module;
                    return module.exports;
                  };
                  fn.__import_remote_external__ = true;
                  __require__.m[external.id] = fn;
                });
                manifest.shareModules && manifest.shareModules.forEach(function (item) {
                  var oldModule = __require__.m[item.id];
                  if (oldModule && (oldModule.__import_remote_shared__ || oldModule.__import_remote_external__)) return;
                  var newModule = requireExternal(item, true) || __remoteModuleWebpack__.shareModules[item.id];
                  if (newModule !== undefined) {
                    var itemVersion = item.version;
                    if (itemVersion) {
                      var getVersion = item.getVersion;
                      var moduleVersion;
                      if (getVersion) {
                        moduleVersion = getVersion.call(item, newModule, __require__.m[item.id], __require__.m);
                      } else {
                        moduleVersion = newModule.version || '';
                        if (!moduleVersion && newModule.__esModule && newModule["default"] && newModule["default"].version) {
                          moduleVersion = newModule["default"].version;
                        }
                      }
                      if ((0, _utils.isFunction)(itemVersion) && !itemVersion.call(item, moduleVersion, newModule, {
                        versionLt: _semver.versionLt,
                        satisfy: _semver.satisfy
                      })) return;
                      if (!moduleVersion) return;
                      if (typeof itemVersion === 'string' && !(0, _semver.satisfy)(itemVersion, moduleVersion)) return;
                      if (Array.isArray(itemVersion)) {
                        var ver1 = itemVersion[0],
                          ver2 = itemVersion[1];
                        if (ver1 && (0, _semver.versionLt)(moduleVersion, ver1)) return;
                        if (ver2 && (0, _semver.versionLt)(ver2, moduleVersion, true)) return;
                      }
                      if (itemVersion instanceof RegExp && !itemVersion.test(moduleVersion)) return;
                    }
                    var fn = function fn(module) {
                      if (module) module.exports = newModule;
                      return newModule;
                    };
                    fn.__import_remote_shared__ = true;
                    __require__.m[item.id] = fn;
                    if (!__remoteModuleWebpack__.shareModules[item.id]) __remoteModuleWebpack__.shareModules[item.id] = newModule;
                  }
                });

                // eslint-disable-next-line no-empty
                if (!context.promisePending) {
                  _context4.next = 59;
                  break;
                }
                _context4.prev = 52;
                _context4.next = 55;
                return context.promisePending;
              case 55:
                _context4.next = 59;
                break;
              case 57:
                _context4.prev = 57;
                _context4.t3 = _context4["catch"](52);
              case 59:
                (0, _utils.innumerable)(context, 'promisePending', Promise.all(manifest.entrys.ids.map(function (id) {
                  return __require__.e(id, true);
                })));
                _context4.prev = 60;
                _context4.next = 63;
                return context.promisePending;
              case 63:
                _context4.prev = 63;
                delete context.promisePending;
                return _context4.finish(63);
              case 66:
                if (!__require__._init) {
                  _context4.next = 69;
                  break;
                }
                _context4.next = 69;
                return __require__._init(manifest.remotes);
              case 69:
                resolve(requireModule(__require__, manifest));
                _context4.next = 76;
                break;
              case 72:
                _context4.prev = 72;
                _context4.t4 = _context4["catch"](1);
                reject(_context4.t4);
                throw _context4.t4;
              case 76:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee3, null, [[1, 72], [52, 57], [60,, 63, 66]]);
      }));
      return function (_x2, _x3) {
        return _ref4.apply(this, arguments);
      };
    }())
  };
  return cached[cacheUrl].result.then(function (r) {
    return resolveResult(r, options);
  });
}
remote.externals = {};
remote.globals = {
  // _interopRequireDefault: require('babel-runtime/helpers/interopRequireDefault').default
};
var _default = remote;
exports["default"] = _default;