"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
exports.isRequireFactory = isRequireFactory;
require("regenerator-runtime/runtime.js");
require("core-js/modules/es6.array.filter.js");
require("core-js/modules/es6.function.name.js");
require("core-js/modules/es6.string.iterator.js");
require("core-js/modules/es6.object.to-string.js");
require("core-js/modules/es6.array.iterator.js");
require("core-js/modules/web.dom.iterable.js");
require("core-js/modules/es6.promise.js");
require("core-js/modules/es6.array.map.js");
require("core-js/modules/es6.array.reduce.js");
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _utils = require("./utils");
/**
 * @typedef {import('../types/requireFactory').RemoteRequireFactory} RemoteRequireFactory
 * @typedef {import('../types/requireFactory').RemoteRequireFactoryMap} RemoteRequireFactoryMap
 */

/**
 * @param {RemoteRequireFactoryMap} modulesMap
 * @returns {Omit<RemoteRequireFactory, '__import_remote_require_factory__'>}
 */
function defaultRequireFactory(modulesMap) {
  return /*#__PURE__*/function () {
    var _requireFactory2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/regeneratorRuntime.mark(function _callee(externals) {
      var moduleExternals, modules;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              moduleExternals = externals.filter(function (external) {
                return (0, _utils.hasOwnProp)(modulesMap, external.name);
              });
              _context.next = 3;
              return Promise.all(moduleExternals.map(function (external) {
                var v = modulesMap[external.name];
                return (0, _utils.isFunction)(v) ? v() : v;
              }));
            case 3:
              modules = _context.sent;
              return _context.abrupt("return", moduleExternals.reduce(function (p, external, i) {
                p[external.name] = modules[i];
                return p;
              }, {}));
            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    function _requireFactory(_x) {
      return _requireFactory2.apply(this, arguments);
    }
    return _requireFactory;
  }();
}

/** @type {import('../types/requireFactory').default} */
function createRequireFactory(factory) {
  if ((0, _utils.isPlainObject)(factory)) factory = defaultRequireFactory(factory);
  (0, _utils.innumerable)(factory, '__import_remote_require_factory__', true);
  return factory;
}

/** @type {import('../types/requireFactory').isRequireFactory} */
function isRequireFactory(fn) {
  return fn && fn.__import_remote_require_factory__;
}
var _default = createRequireFactory;
exports["default"] = _default;