"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.DEFAULT_TIMEOUT = exports.ATTR_SCOPE_NAME = void 0;
exports.copyOwnProperties = copyOwnProperties;
exports.copyOwnProperty = copyOwnProperty;
exports.getCacheUrl = getCacheUrl;
exports.getHostFromUrl = getHostFromUrl;
exports.hasOwnProp = hasOwnProp;
exports.innumerable = innumerable;
exports.isEvalDevtool = isEvalDevtool;
exports.isFunction = isFunction;
exports.isPlainObject = isPlainObject;
exports.isRegExp = isRegExp;
exports.isSameHost = isSameHost;
exports.mergeObject = mergeObject;
exports.requireFromStr = requireFromStr;
exports.requireWithVersion = requireWithVersion;
exports.resolveRelativeUrl = resolveRelativeUrl;
exports.transformSourcemapUrl = transformSourcemapUrl;
exports.walkMainifest = walkMainifest;
var _construct2 = _interopRequireDefault(require("@babel/runtime/helpers/construct"));
require("core-js/modules/es6.object.assign.js");
require("core-js/modules/es6.array.for-each.js");
require("core-js/modules/es6.object.keys.js");
require("core-js/modules/es6.regexp.split.js");
require("core-js/modules/es6.object.to-string.js");
require("core-js/modules/es6.array.find.js");
require("core-js/modules/es6.regexp.constructor.js");
require("core-js/modules/es6.array.index-of.js");
require("core-js/modules/es6.array.is-array.js");
require("core-js/modules/es6.regexp.replace.js");
require("core-js/modules/es6.array.slice.js");
require("core-js/modules/es6.string.starts-with.js");
require("core-js/modules/es6.object.get-own-property-descriptor.js");
require("core-js/modules/es6.object.define-property.js");
require("core-js/modules/es6.object.get-own-property-names.js");
var _objdp = require("./_objdp");
exports.objectDefineProperty = _objdp.objectDefineProperty;
var _fetch = require("./fetch");
exports.isAbsoluteUrl = _fetch.isAbsoluteUrl;
exports.joinUrl = _fetch.joinUrl;
var DEFAULT_TIMEOUT = 120000;
exports.DEFAULT_TIMEOUT = DEFAULT_TIMEOUT;
var ATTR_SCOPE_NAME = 'data-remote-scope';

/** @type {import('types/utils').requireFromStr} */
exports.ATTR_SCOPE_NAME = ATTR_SCOPE_NAME;
function requireFromStr(source, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
    _ref$global = _ref.global,
    context = _ref$global === void 0 ? window : _ref$global,
    url = _ref.url,
    _ref$moduleProps = _ref.moduleProps,
    moduleProps = _ref$moduleProps === void 0 ? {} : _ref$moduleProps;
  // eslint-disable-next-line no-useless-catch
  var _module = Object.assign({
    inRemoteModule: true,
    exports: {}
  }, moduleProps);
  var names = ['module', 'exports'];
  var args = [_module, _module.exports];
  if (context && context !== window) {
    Object.keys(context).forEach(function (key) {
      var v = context[key];
      if (v == null) {
        if (key !== '_wp_') return;
        v = window;
        if (!v.d || !v.doc) v.doc = v.d = window.document;
        if (!v.globals || !v.g) v.g = v.globals = {};
      }
      names.push(key);
      args.push(v);
    });
  }
  if (url && !/\/\/# sourceURL=[\w./_:?&%=#+-]+\.js$/.test(source)) source += "\n//# sourceURL=" + url;
  // eslint-disable-next-line no-new-func
  (0, _construct2["default"])(Function, names.concat([source])).apply(context, args);
  return _module.exports;
}

/** @type {import('types/utils').resolveRelativeUrl} */
function resolveRelativeUrl(url, options) {
  if (options === void 0) {
    options = {};
  }
  if (!url || (0, _fetch.isAbsoluteUrl)(url)) return url;
  var host = options.host || window.location.origin;
  if (/^\.\//.test(url)) {
    url = url.substr(2, url.length);
    if (!options.host) {
      host = "" + host + window.location.pathname;
      if (/\.(html?|js)$/.test(host)) {
        var paths = host.split('/');
        paths.pop();
        host = paths.join('/');
      }
      options.onHost && options.onHost(host);
    }
  }
  return (0, _fetch.joinUrl)(host, url);
}
var _toString = Object.prototype.toString;

/** @type {import('types/utils').isPlainObject} */
function isPlainObject(obj) {
  return _toString.call(obj) === '[object Object]';
}

/** @type {import('types/utils').isRegExp} */
function isRegExp(obj) {
  return _toString.call(obj) === '[object RegExp]';
}

/** @type {import('types/utils').isFunction} */
function isFunction(fn) {
  return fn && typeof fn === 'function' && (!fn.prototype || fn.prototype === Function || fn.constructor === Function);
}

/** @type {import('types/utils').mergeObject} */
function mergeObject(target) {
  function _mergeObject(target, source, copiedObjects) {
    if (!target) return target;
    if (!isPlainObject(source)) return target;
    copiedObjects.push({
      source: source,
      target: target
    });
    Object.keys(source).forEach(function (key) {
      var v = source[key];
      if (isPlainObject(v)) {
        var copied = copiedObjects.find(function (c) {
          return c.source === v;
        });
        if (copied) target[key] = copied.target;else {
          var w = target[key];
          if (!isPlainObject(w)) w = target[key] = {};
          Object.keys(v).forEach(function (key2) {
            return w[key2] = v[key2];
          });
        }
      } else target[key] = v;
    });
    return target;
  }
  var ret = target;
  var copiedObjects = [];
  for (var i = 1; i < arguments.length; i++) {
    _mergeObject(ret, arguments[i], copiedObjects);
  }
  return ret;
}

/**
 * @template T
 * @type {import('types/utils').walkMainifest<T>}
 */
function walkMainifest(target) {
  var copied = [];
  var _getItem = function _getItem(ret) {
    if (ret && ret._t && ret._v) {
      if (ret._t === 'f') {
        var _ret$_v = ret._v,
          args = _ret$_v[0],
          body = _ret$_v[1],
          bracket = _ret$_v[2];
        // eslint-disable-next-line no-new-func
        ret = (0, _construct2["default"])(Function, args.concat(["\"use strict\";" + (bracket ? '' : 'return (') + "\n" + body + (bracket ? '' : '\n)')]));
      } else if (ret._t === 'r') {
        ret = new RegExp(ret._v, ret._f);
      } else if (ret._t === 'd') {
        ret = new Date(ret._v);
      }
    }
    return ret;
  };
  function _walk(target, copied) {
    if (!target || ~copied.indexOf(target)) return target;
    var isObject;
    if (isPlainObject(target)) {
      if (target._t && target._v) return _getItem(target);
      isObject = true;
    }
    if (isObject || Array.isArray(target)) {
      copied.push(target);
      Object.keys(target).forEach(function (key) {
        target[key] = _walk(target[key], copied);
      });
    }
    return target;
  }
  return _walk(target, copied);
}

/** @type {import('types/utils').innumerable} */
function innumerable(obj, key, value, options) {
  if (options === void 0) {
    options = {
      configurable: true,
      writable: true
    };
  }
  (0, _objdp.objectDefineProperty)(obj, key, Object.assign({
    value: value
  }, options));
  return obj;
}
var _hasOwnProperty = Object.prototype.hasOwnProperty;
/** @type {import('types/utils').hasOwnProp} */
function hasOwnProp(obj, propName) {
  return _hasOwnProperty.call(obj, propName);
}

/** @type {import('types/utils').getHostFromUrl} */
function getHostFromUrl(url) {
  url = url.replace(/((https?:)?\/\/[^?#]*).*/g, '$1');
  if (!/\.js$/.test(url)) return url;
  var urls = url.replace(/((https?:)?\/\/[^?#]*).*/g, '$1').split('/');
  urls.pop();
  return urls.join('/');
}

/** @type {import('types/utils').isEvalDevtool} */
function isEvalDevtool(devtool) {
  return typeof devtool === 'string' && /^(eval|inline)/.test(String(devtool));
}

/** @type {import('types/utils').requireWithVersion} */
function requireWithVersion(module, version) {
  if (module && !module.version) innumerable(module, 'version', version);
  return module;
}

/** @type {import('types/utils').isSameHost} */
function isSameHost(host1, host2) {
  host1 = host1.replace(/\/+$/, '');
  host2 = host2.replace(/\/+$/, '');
  return host1.toLowerCase() === host2.toLowerCase();
}
var sourceMappingURLCssRegx = /\/\*# sourceMappingURL=([0-9A-Za-z_.-]+\.(?:js|css)\.map)\*\/$/;
var sourceMappingURLJsRegx = /\/\/# sourceMappingURL=([0-9A-Za-z_.-]+\.(?:js|css)\.map)$/;
/**
 * @param {string} href
 * @param {string} source
 * @param {import('../types/importJs').RemoteImportOptions} [options]
 */
function transformSourcemapUrl(href, source, _temp2) {
  var _ref2 = _temp2 === void 0 ? {} : _temp2,
    devtool = _ref2.devtool,
    sourcemapHost = _ref2.sourcemapHost,
    scopeName = _ref2.scopeName,
    host = _ref2.host,
    publicPath = _ref2.publicPath;
  if (devtool) {
    if (isFunction(sourcemapHost)) sourcemapHost = sourcemapHost({
      scopeName: scopeName,
      host: host,
      publicPath: publicPath,
      href: href,
      source: source
    });
    if (!sourcemapHost) sourcemapHost = href.split('/').slice(0, -1).join('/');else {
      if (/\/$/.test(sourcemapHost)) sourcemapHost = sourcemapHost.substr(0, sourcemapHost.length - 1);
      sourcemapHost = (0, _fetch.joinUrl)(sourcemapHost, href.substr(publicPath.length, href.length).split('/').slice(0, -1).join('/'));
    }
    if (/\.css$/i.test(href)) {
      source = source.replace(sourceMappingURLCssRegx, function (m, p1) {
        return "/*# sourceMappingURL=" + (0, _fetch.joinUrl)(sourcemapHost, p1) + "*/";
      });
    } else {
      source = source.replace(sourceMappingURLJsRegx, function (m, p1) {
        return "//# sourceMappingURL=" + (0, _fetch.joinUrl)(sourcemapHost, p1);
      });
    }
  } else if (scopeName) {
    var _sourcemapHost = sessionStorage.getItem("import-remote-" + scopeName + "-sourcemapping-host");
    if (_sourcemapHost && href.startsWith(host)) {
      source = source + "\n//# sourceMappingURL=" + (0, _fetch.joinUrl)(_sourcemapHost, href.substr(host.length, href.length)) + ".map";
    }
  }
  return source;
}

/** @type {import('types/utils').getCacheUrl} */
function getCacheUrl(url, scopeName) {
  if (!scopeName || typeof scopeName !== 'string') return url;
  return url + ((url.indexOf('?') >= 0 ? '&' : '?') + "scopeName=" + encodeURIComponent(scopeName));
}

/** @type {import('types/utils').copyOwnProperties} */
function copyOwnProperty(target, key, source) {
  if (!target || !source) return;
  var d = Object.getOwnPropertyDescriptor(source, key);
  d && Object.defineProperty(target, key, d);
  return d;
}

/**
 * @template T
 * @type {import('types/utils').copyOwnProperties<T>}
 * */
function copyOwnProperties(target, source, overwrite) {
  if (!target || !source) return target;
  Object.getOwnPropertyNames(source).forEach(function (key) {
    if (!overwrite && hasOwnProp(target, key)) return;
    copyOwnProperty(target, key, source);
  });
  return target;
}