"use strict";

require("core-js/modules/es6.weak-map.js");
require("core-js/modules/es6.string.iterator.js");
require("core-js/modules/es6.object.to-string.js");
require("core-js/modules/es6.array.iterator.js");
require("core-js/modules/web.dom.iterable.js");
require("core-js/modules/es6.object.define-property.js");
require("core-js/modules/es6.object.get-own-property-descriptor.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.RemoteApp = void 0;
exports.createAppView = createAppView;
exports.createModuleApp = createModuleApp;
exports["default"] = void 0;
require("core-js/modules/es6.object.assign.js");
require("core-js/modules/es6.array.is-array.js");
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _react = _interopRequireWildcard(require("react"));
var _utils = require("./utils");
var _ = _interopRequireDefault(require("../.."));
var _excluded = ["id", "className", "style"],
  _excluded2 = ["src", "module", "moduleName", "exportName", "hoc", "children", "clearWhenError", "style", "showChildren"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function createAppView(view, options) {
  if (options === void 0) {
    options = {};
  }
  if (view && view.__esModule) view = view[options.exportName || 'default'];
  if (!view) return null;
  if (typeof view === 'function' || (0, _utils.isReactComponent)(view) || (0, _utils.isForwardComponent)(view)) {
    return view;
  }
  var RemoteAppView = /*#__PURE__*/function (_React$Component) {
    (0, _inheritsLoose2["default"])(RemoteAppView, _React$Component);
    function RemoteAppView(props) {
      var _this;
      _this = _React$Component.call(this, props) || this;
      if (view.bootstrap) view.bootstrap(props, options);
      return _this;
    }
    var _proto = RemoteAppView.prototype;
    _proto._getAppProps = function _getAppProps(props) {
      var id = props.id,
        className = props.className,
        style = props.style,
        otherProps = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded);
      if (props.children) (0, _utils.innumerable)(otherProps, 'children', props.children);
      return {
        id: id,
        className: className,
        style: style,
        otherProps: otherProps
      };
    };
    _proto.componentDidMount = function componentDidMount() {
      var _this2 = this;
      var props = this._getAppProps(this.props).otherProps;
      if (view.mounted) {
        return view.mounted(this.root, props);
      }
      if (view.init || view.forceInit) {
        var prom = (view.init || view.forceInit)(props, options);
        if (prom && prom.then) {
          prom.then(function () {
            return view.render && view.render(_this2.root, props);
          });
        } else view.render && view.render(this.root, props);
      }
    };
    _proto.componentWillUnmount = function componentWillUnmount() {
      if (view.unmount) view.unmount(this.root);else if (view.destroy) view.destroy(this.root);else if (view.destory) view.destory(this.root);
    };
    _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
      var newProps = this._getAppProps(this.props).otherProps;
      var oldProps = this._getAppProps(prevProps).otherProps;
      if (view.update) view.update(this.root, newProps, oldProps);else if (view.mounted) view.mounted(this.root, newProps);else if (view.init || view.forceInit) (view.init || view.forceInit)(newProps);
    };
    _proto.render = function render() {
      var _this3 = this;
      var props = {
        className: 'import-remote-app'
      };
      if (view.inheritAttrs !== false) {
        var _this$_getAppProps = this._getAppProps(this.props),
          id = _this$_getAppProps.id,
          className = _this$_getAppProps.className,
          style = _this$_getAppProps.style;
        Object.assign(props, {
          id: id,
          style: style
        });
        if (className) props.className += " " + className;
      }
      return _react["default"].createElement('div', Object.assign({}, props, {
        ref: function ref(el) {
          return _this3.el = el;
        }
      }));
    };
    (0, _createClass2["default"])(RemoteAppView, [{
      key: "root",
      get: function get() {
        var _options = options,
          shadow = _options.shadow;
        if (shadow && !this.shadowEl && _utils.supportShadow) {
          this.shadowEl = (0, _utils.createShadowRoot)(this.el);
        }
        return shadow ? this.shadowEl || this.el : this.el;
      }
    }]);
    return RemoteAppView;
  }(_react["default"].Component);
  RemoteAppView.__import_remote_app__ = true;
  return RemoteAppView;
}
function requireApp(url, options) {
  if (options === void 0) {
    options = {};
  }
  return (0, _["default"])(url, options).then(function (view) {
    return createAppView(view, options);
  });
}
var RemoteApp = _react["default"].forwardRef(
/**
 * @param {import('../types/app').RemoteAppProps} props
 * @param {*} ref
 */
function (props, ref) {
  var _props$src = props.src,
    src = _props$src === void 0 ? '' : _props$src,
    module = props.module,
    moduleName = props.moduleName,
    _props$exportName = props.exportName,
    exportName = _props$exportName === void 0 ? 'default' : _props$exportName,
    hoc = props.hoc,
    children = props.children,
    _props$clearWhenError = props.clearWhenError,
    clearWhenError = _props$clearWhenError === void 0 ? true : _props$clearWhenError,
    _props$style = props.style,
    style = _props$style === void 0 ? {} : _props$style,
    showChildren = props.showChildren,
    restProps = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded2);
  var _useState = (0, _react.useState)({
      App: null
    }),
    app = _useState[0],
    setApp = _useState[1];
  var _useState2 = (0, _react.useState)({}),
    $refs = _useState2[0];
  var App = app.App;
  $refs.hoc = hoc;
  $refs.clearWhenError = clearWhenError;
  (0, _react.useEffect)(function () {
    if (!src && (!module || !moduleName)) return;
    (src ? (0, _["default"])(src) : module.require(moduleName)).then(function (esModule) {
      var App = createAppView(esModule.__esModule ? esModule[exportName] : esModule);
      if ($refs.hoc) App = $refs.hoc(App);
      setApp({
        App: App
      });
    })["catch"](function (e) {
      if ($refs.clearWhenError) {
        var _App = $refs.hoc && $refs.hoc(null, e) || null;
        setApp({
          App: _App
        });
      }
      return e;
    });
  }, [src, module, moduleName, exportName, $refs]);
  var displayStyle = (0, _react.useMemo)(function () {
    if ($refs.App) return style;
    var _style = Object.assign({}, style);
    if (restProps.height && !_style.height) _style.height = restProps.height;
    if (restProps.width && !_style.width) _style.width = restProps.width;
    return _style;
  }, [$refs.App, style, restProps.height, restProps.width]);
  return App ? _react["default"].createElement(App, Object.assign({}, ref ? {
    ref: ref
  } : {}, {
    style: displayStyle
  }, restProps), children) : children && (!Array.isArray(children) || children.length) ? _react["default"].createElement('i', {
    className: restProps.className,
    style: Object.assign({}, displayStyle, {
      visibility: 'hidden'
    })
  }, showChildren ? children : null) : null;
});
exports.RemoteApp = RemoteApp;
function createModuleApp(remoteModule, initProps) {
  if (initProps === void 0) {
    initProps = {};
  }
  var RemoteAppWrapper = _react["default"].forwardRef(function (props, ref) {
    return _react["default"].createElement(RemoteApp, Object.assign({
      module: remoteModule
    }, initProps, ref ? {
      ref: ref
    } : {}, props), props.children);
  });
  return RemoteAppWrapper;
}
var _default = requireApp;
exports["default"] = _default;