"use strict";

exports.__esModule = true;
exports.createDOMElement = createDOMElement;
exports.createShadowRoot = createShadowRoot;
exports.innumerable = innumerable;
exports.isForwardComponent = isForwardComponent;
exports.isReactComponent = isReactComponent;
exports.supportShadow = void 0;
require("core-js/modules/es6.symbol.js");
require("core-js/modules/es6.array.for-each.js");
require("core-js/modules/es6.object.keys.js");
require("core-js/modules/es6.object.assign.js");
var _require = require('../..'),
  objectDefineProperty = _require.objectDefineProperty;
var hasSymbol = typeof Symbol === 'function' && Symbol["for"];
var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol["for"]('react.forward_ref') : 0xead0;
var supportShadow = Boolean(document.body.attachShadow || document.body.createShadowRoot);
exports.supportShadow = supportShadow;
function createShadowRoot(el) {
  return el.attachShadow ? el.attachShadow({
    mode: 'open'
  }) : el.createShadowRoot();
}
function isReactComponent(component) {
  return component && component.prototype && component.prototype.render && component.isReactClass;
}
function isForwardComponent(component) {
  return component && component.$$typeof === REACT_FORWARD_REF_TYPE && typeof component.render === 'function';
}
function createDOMElement(tag, props, container) {
  if (props === void 0) {
    props = {};
  }
  var el = document.createElement(tag);
  if (props.className) el.className = props.className;
  if (props.style) {
    Object.keys(props.style).forEach(function (key) {
      return el.style[key] = props.style[key];
    });
  }
  if (container) container.appendChild(el);
  return el;
}
function innumerable(obj, key, value, options) {
  if (options === void 0) {
    options = {
      configurable: true
    };
  }
  objectDefineProperty(obj, key, Object.assign({
    value: value
  }, options));
  return obj;
}