"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
require("core-js/modules/es6.array.for-each.js");
require("core-js/modules/es6.string.includes.js");
require("core-js/modules/es7.array.includes.js");
require("core-js/modules/es6.regexp.replace.js");
require("core-js/modules/es6.array.filter.js");
require("core-js/modules/es6.regexp.split.js");
require("core-js/modules/es6.object.assign.js");
require("core-js/modules/es6.array.find-index.js");
require("core-js/modules/es6.string.starts-with.js");
require("core-js/modules/es6.object.keys.js");
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _react = _interopRequireDefault(require("react"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _hashSum = _interopRequireDefault(require("hash-sum"));
var _ = _interopRequireDefault(require("../.."));
var _app = require("./app");
var _utils = require("./utils");
// eslint-disable-next-line no-useless-escape
var REGX_CSS_SELECTOR = /((?:^|[\n},]|(?:"UTF\-8";(?:\/\*.*\*\/)?)|(?:\.css\);)))([^{},\s();/\\@\d][^{},\s();/\\@]*)/ig;
var REGX_CSS_FUNC_VALUE = /^url$/;
// eslint-disable-next-line max-len
// /^(url|black|white|red|green|blue|yellow|pink|gray|gold|orange|olive|purple|silver|[-?\d.]+(?:deg|grad|rad|turn|v[h|w]|vmax|vmin|c[mh]|mm|in|%|r?e[mx]|p[xtc]|m?s)|#[a-z0-9]+)$/;

var RemoteViewSeed = 0;
var RemoteView = /*#__PURE__*/function (_React$Component) {
  (0, _inheritsLoose2["default"])(RemoteView, _React$Component);
  function RemoteView(props) {
    var _this;
    _this = _React$Component.call(this, props) || this;
    _this.$refs = {};
    _this.state = {
      loading: false,
      viewSrc: '',
      view: null
    };
    _this.viewContext = {
      cached: {}
    };
    _this.viewScopeName = null;
    _this.viewScopeSeed = ++RemoteViewSeed;
    _this.listeners = [];
    return _this;
  }
  var _proto = RemoteView.prototype;
  _proto.componentDidMount = function componentDidMount() {
    this._loadView();
  };
  _proto.componentWillMount = function componentWillMount() {
    this._destoryView();
  };
  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState, snapshot) {
    if (this.props.src !== prevProps.src) {
      this._loadView();
    }
  };
  _proto.reload = function reload() {
    this._destoryView(this.viewScopeName);
    this._loadView();
  };
  _proto._destoryView = function _destoryView(viewScopeName) {
    if (!viewScopeName) viewScopeName = this.viewScopeName;
    if (!viewScopeName) return;
    var scopeName = viewScopeName;
    var listeners = this.viewContext[scopeName] && this.viewContext[scopeName].listeners;
    if (listeners) {
      listeners.forEach(function (v) {
        return window.removeEventListener(v.type, v.listener);
      });
      listeners.splice(0, listeners.length);
    }
    var els = document.querySelectorAll(scopeName);
    els.forEach(function (el) {
      return el.parent && el.parent.removeChild(el);
    });
    delete this.viewContext[scopeName];
    var bodyEl = this.$refs.body;
    var bodyClassName = bodyEl && bodyEl.className;
    if (this.viewScopeHash && bodyClassName.includes(this.viewScopeHash)) {
      bodyClassName = bodyClassName.replace(this.viewScopeHash, '');
    }
    if (this.viewNamespace && bodyClassName.includes(this.viewNamespace)) {
      bodyClassName = bodyClassName.replace(this.viewNamespace, '');
    }
    if (bodyClassName !== bodyEl.className) bodyEl.className = bodyClassName.split(' ').filter(Boolean).join(' ');
    this.viewScopeName = '';
    this.viewScopeHash = '';
    this.viewNamespace = '';
    this.viewManifest = null;
  };
  _proto._loadView = function _loadView() {
    var _this2 = this;
    var _this$props = this.props,
      src = _this$props.src,
      externals = _this$props.externals,
      scopePrefix = _this$props.scopePrefix,
      scopeStyle = _this$props.scopeStyle,
      module = _this$props.module,
      moduleName = _this$props.moduleName,
      classPrefix = _this$props.classPrefix,
      shadow = _this$props.shadow,
      exportName = _this$props.exportName,
      transfromHtmlBodyTagClass = _this$props.transfromHtmlBodyTagClass,
      hoc = _this$props.hoc,
      onViewLoading = _this$props.onViewLoading,
      onViewError = _this$props.onViewError;
    var viewSrc = this.state.viewSrc;
    var _require = function _require(options) {
      return (0, _["default"])(src, options);
    };
    if (!src && module) {
      src = moduleName ? module.resolveModuleUrl(moduleName) : '';
      _require = function _require(options) {
        if (options.externals === undefined) delete options.externals;
        return module.require(moduleName, options);
      };
    }
    if (viewSrc === src) return;
    if (!src) {
      return this.setState({
        loading: false,
        viewSrc: '',
        view: null
      });
    }
    this.setState({
      loading: true
    });
    onViewLoading && onViewLoading(true);
    var oldScopeName = null;
    var _finally = function _finally() {
      _this2.setState(Object.assign({
        loading: false
      }, state), function () {
        onViewLoading && onViewLoading(false);
        if (oldScopeName && oldScopeName !== _this2.viewScopeName) _this2._destoryView(oldScopeName);
      });
    };
    var bodyEl = this.$refs.body;
    var state = {};
    _require({
      externals: externals,
      windowProxy: {
        context: this.viewContext,
        document: {
          html: this.$refs.html,
          head: this.$refs.head,
          body: this.$refs.body
        },
        addEventListener: function addEventListener(type, listener) {
          var _window;
          if (this.viewScopeName) {
            var viewContext = this.viewContext[this.viewScopeName];
            if (viewContext) {
              var listeners = viewContext && viewContext.listeners;
              if (!listeners) viewContext.listeners = [];
              listeners.push(type, listener);
            }
          }
          for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
            args[_key - 2] = arguments[_key];
          }
          return (_window = window).addEventListener.apply(_window, [type, listener].concat(args));
        },
        removeEventListener: function removeEventListener(type, listener) {
          var _window2;
          if (this.viewScopeName) {
            var viewContext = this.viewContext[this.viewScopeName];
            if (viewContext) {
              var listeners = viewContext && viewContext.listeners;
              if (listeners) {
                var idx = listeners.findIndex(function (v) {
                  return v.listener === listener;
                });
                if (~idx) listeners.splice(idx, 1);
              }
            }
          }
          for (var _len2 = arguments.length, args = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
            args[_key2 - 2] = arguments[_key2];
          }
          return (_window2 = window).removeEventListener.apply(_window2, [type, listener].concat(args));
        }
      },
      beforeSource: function beforeSource(source, type) {
        if (scopeStyle && (!shadow || !_utils.supportShadow || scopeStyle === 'always') && type === 'css') {
          source = source.replace(REGX_CSS_SELECTOR, function (m, p1, p2) {
            var p2LowerCase = p2 ? p2.toLowerCase() : '';
            if (REGX_CSS_FUNC_VALUE.test(p2LowerCase)) return p1 + p2;
            var isHtmlBodyEl = transfromHtmlBodyTagClass && /^(html|head|body)\b/.test(p2LowerCase);
            if (isHtmlBodyEl) p2 = "." + classPrefix + "view" + (p2LowerCase.startsWith('html') ? '' : '-' + p2LowerCase);
            return p1 + " ." + _this2.viewScopeHash + (isHtmlBodyEl ? '' : ' ') + p2;
          });
        }
        return source;
      },
      getManifestCallback: function getManifestCallback(viewManifest) {
        var newScopeName = viewManifest.scopeName;
        if (_this2.viewScopeName === newScopeName) return;
        oldScopeName = _this2.viewScopeName;
        _this2.viewScopeName = newScopeName;
        _this2.viewScopeHash = "" + scopePrefix + (0, _hashSum["default"])(newScopeName + _this2.viewScopeSeed);
      }
    }).then(function (view) {
      if (view && view.__esModule) view = view[exportName];
      if (view.namespace && bodyEl && !bodyEl.className.includes(view.namespace)) {
        _this2.viewNamespace = view.namespace;
        bodyEl.className = bodyEl.className + " " + view.namespace;
      }
      if (typeof view === 'function' && !(0, _utils.isReactComponent)(view) && !(0, _utils.isForwardComponent)(view)) {
        view = (0, _app.createAppView)(view);
      }
      if (hoc) view = hoc(view);
      Object.assign(state, {
        view: view,
        viewSrc: src
      });
      _finally();
    })["catch"](function (ex) {
      var errorView = onViewError && onViewError(ex);
      if (hoc) errorView = hoc(errorView, ex);
      if (errorView !== undefined) Object.assign(state, {
        view: errorView,
        viewSrc: ''
      });
      _finally();
    });
  };
  _proto.render = function render() {
    var _this3 = this;
    var _this$props2 = this.props,
      shadow = _this$props2.shadow,
      classPrefix = _this$props2.classPrefix,
      tag = _this$props2.tag,
      className = _this$props2.className,
      children = _this$props2.children,
      _this$props2$props = _this$props2.props,
      props = _this$props2$props === void 0 ? {} : _this$props2$props,
      _this$props2$style = _this$props2.style,
      style = _this$props2$style === void 0 ? {} : _this$props2$style,
      _this$props2$bodyStyl = _this$props2.bodyStyle,
      bodyStyle = _this$props2$bodyStyl === void 0 ? {} : _this$props2$bodyStyl,
      scopePrefix = _this$props2.scopePrefix,
      transfromHtmlBodyTagClass = _this$props2.transfromHtmlBodyTagClass,
      module = _this$props2.module,
      moduleName = _this$props2.moduleName,
      exportName = _this$props2.exportName;
    var otherProps = {};
    Object.keys(this.props).forEach(function (key) {
      // eslint-disable-next-line react/forbid-foreign-prop-types
      if (RemoteView.propTypes[key]) return;
      otherProps[key] = _this3.props[key];
    });
    var shadowChild = shadow && _utils.supportShadow;
    var _this$state = this.state,
      loading = _this$state.loading,
      View = _this$state.view;
    return _react["default"].createElement(tag, Object.assign({
      key: 'view-html',
      className: this.viewScopeHash + " " + classPrefix + "view  " + (shadowChild ? '' : classPrefix + "view-html") + " " + (loading ? classPrefix + "view-loading" : '') + " " + (className || ''),
      style: style,
      ref: function ref(r) {
        if (r && !_this3.$refs.shadowRoot && shadowChild) {
          _this3.$refs.root = r;
          _this3.$refs.shadowRoot = (0, _utils.createShadowRoot)(r);
          _this3.$refs.html = (0, _utils.createDOMElement)(tag, {
            className: classPrefix + "view-html"
          }, _this3.$refs.shadowRoot);
          _this3.$refs.head = (0, _utils.createDOMElement)(tag, {
            className: classPrefix + "view-head"
          }, _this3.$refs.html);
          _this3.$refs.body = (0, _utils.createDOMElement)(tag, {
            className: classPrefix + "view-body"
          }, _this3.$refs.html);
          _this3.forceUpdate();
        } else _this3.$refs.html = r;
      }
    }, otherProps), shadowChild ? this.$refs.body && View ? _reactDom["default"].createPortal(_react["default"].createElement(View, props, children), this.$refs.body) : null : [_react["default"].createElement(tag, {
      key: 'view-head',
      className: this.viewScopeHash + " " + classPrefix + "view-head",
      ref: function ref(r) {
        return _this3.$refs.head = r;
      }
    }), _react["default"].createElement(tag, {
      key: 'view-body',
      className: this.viewScopeHash + " " + classPrefix + "view-body",
      style: bodyStyle,
      ref: function ref(r) {
        return _this3.$refs.body = r;
      }
    }, View ? _react["default"].createElement(View, props, children) : null)]);
  };
  return RemoteView;
}(_react["default"].Component);
RemoteView.propTypes = {
  scopeStyle: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].oneOf(['always'])]),
  scopePrefix: _propTypes["default"].string,
  classPrefix: _propTypes["default"].string,
  className: _propTypes["default"].string,
  transfromHtmlBodyTagClass: _propTypes["default"].bool,
  style: _propTypes["default"].object,
  bodyStyle: _propTypes["default"].object,
  shadow: _propTypes["default"].bool,
  tag: _propTypes["default"].string,
  src: _propTypes["default"].string,
  module: _propTypes["default"].object,
  moduleName: _propTypes["default"].string,
  exportName: _propTypes["default"].string,
  props: _propTypes["default"].object,
  externals: _propTypes["default"].object,
  onViewLoading: _propTypes["default"].func,
  onViewError: _propTypes["default"].func,
  hoc: _propTypes["default"].func
};
RemoteView.defaultProps = {
  scopePrefix: 'v-',
  classPrefix: 'import-remote-',
  tag: 'div',
  exportName: 'default',
  transfromHtmlBodyTagClass: true
};
var _default = RemoteView;
exports["default"] = _default;